/* Name:     main.c
 * Project:  LED_CLOUD
 * Ver:      1.0
 * Author:   r13-project.ru
 * Creation  Date: 06-03-20
 */
#include <stdlib.h>
#include <math.h> 
#include <avr/io.h>           
#include <util/delay.h>       
#include <avr/interrupt.h>    
#include "twi.c"              
#include "ssd1306.c"          //  и так сойдет лень Makefile ковырять :)
#include "lookup.h"
#include "light_ws2812.c"     //  и так сойдет лень Makefile ковырять :)
#include	<avr/pgmspace.h>
#include "avr/eeprom.h"
////////////////////////////////////////////////////////////////////////
#define N 34
#define RX_BUFFER_SIZE0 8
#define LED_PIN   2         	// Пин на котором висит лента
unsigned char MAX_LED;     	// Количество диодов в 2 раза меньше N-1
#define MAX_F     255     	    // Максимальная яркость ленты для цветомузыки минимум 50 максимум 255
#define in_buffer_SIZE 8    	// USART входной - USB выходной
////////////////////////////////////////////////////////////////////////
int32_t         adc[N];   						// Хранение данных с АЦП
int32_t         out_f[N/2][2];   				// Промежуточный буфер для преобразования
char volatile            flg=1;
unsigned char   k=0;
struct          cRGB led[32];   				// Структура для хранения (видеопамять) выделяем на всю свободную оперативу - все равно простаивает.
struct          cRGB led_dot[1];   				// Структура для хранения пикселя
unsigned char   rezim;     	        			// 0-молнии 1-цветомузыка 2-ночник 3-переливающаяся радуга
unsigned char   bright;							// яркость
unsigned char   speed;							// скорость
volatile int    SEND_OK=0; 						// Флаг отработки конца приема данных
unsigned char   in_buffer[in_buffer_SIZE]; 		// USART входной
volatile unsigned char in_index=16; 			// номер байта записи
unsigned char EEMEM bitrate;					// битрейт 0-9600_1-14400...19200 38400 56000
unsigned char EEMEM rez;						// Режим
unsigned char EEMEM br;							// Яркость
unsigned char EEMEM sp;							// Скорость
unsigned char EEMEM K_L;						// количесво диодов
///////////////////////////////////////////////////////////////////////
void ADC_Init(char n);               			// читать с порта n
uint16_t ADC_read();                 			// Получить значение с АЦП
void TIMER_init();                   			// Настройка таймера
void FU_transform();                 			// Пеобразовние буфера АЦП
void clear_LED(void);                			// очистить ленту
void raduga(unsigned char KOL_LED);   			// заполняем буфер радугой
void flash(void);                     			// Вспышки молнии
void UART_Init(void);				 			// Настройка uart
void decode(char *buff);	 		 			// проанализировать полученый по uart пакет
void step_right_loop(void);						// двиг пикселей по кругу на 1
void color_decode(unsigned char c);				// декодер байта скорость-цвет
void led_full(void);							//заливка буфера ленты 1 цветом
///////////////////////////////////////////////////////////////////////

ISR(__vector_default)
{
}

ISR( TIMER1_OVF_vect ) 							//чтение данных из АЦП для анализа
{
		//250
		TCNT1H=0xFFC0 >> 8;
		TCNT1L=0xFFC0 & 0xff;
		//
		//160
		/*TCNT1H=0xFF9C >> 8;
		TCNT1L=0xFF9C & 0xff;*/
		//
	if (k<N){
		adc[k] = (ADC_read());
		k++;

	}
	else{
		k=0;
		flg=0;
		TIMSK1=(0<<ICIE1) | (0<<OCIE1B) | (0<<OCIE1A) | (0<<TOIE1);
	}
}

void color_decode(unsigned char c){
	unsigned char color;
	if (c!=0){ 
		color=c;
	}
	else{
		color=255-speed;
	}
	if(color==0){
			led_dot[0].r=255;
			led_dot[0].g=255;
			led_dot[0].b=255;	
	}
	else{
		if(color<85){
			led_dot[0].r=3*(85-color);
			led_dot[0].g=3*color;
			led_dot[0].b=0;	
		}
		else{
			if(color<=170){
				led_dot[0].r=0;
				led_dot[0].g=3*(170-color);
				led_dot[0].b=3*(color-85);			
			}
			else{
					led_dot[0].r=3*(color-170);
					led_dot[0].g=0;
					led_dot[0].b=255-(3*(color-170));			
			}
		}
	}	
}

void dekode(unsigned char *p){  				//декодируем полученый пакет
	char i=0;
//	cli();
	if (*p=='L'){				//Если изменение яркости	
		p++;
		while (*p!='%'){
			i=i*10+*p-48;
			p++;
		}
		bright=i;
	}
	else{
		if (*p=='S'){			//Если изменение скорости
		p++;
		while (*p!='%'){
			i=i*10+*p-48;
			p++;
		}
		speed=255-i;
		}
		else{
			if (*p=='R'){		//Если изменение режима
				p++;
				rezim=*p-48;
			}
			else{
				if (*p=='#'){		//Сохранение настроек
					eeprom_write_byte(&rez,rezim);							// режим
					eeprom_write_byte(&br,bright);							// яркость
					eeprom_write_byte(&sp,speed);							// скорость
					//void eeprom_write_byte (uint8_t *addr, uint8_t value)
				}
				else{
					if (*p=='B'){		//Если изменение битрейта
					p++;
					eeprom_write_byte(&bitrate,*p-48);
					}
					else{
					if (*p=='K'){		//количесво диодов
						p++;
						while (*p!='%'){
							i=i*10+*p-48;
							p++;
						}
						eeprom_write_byte(&K_L,i);
						clear_LED();
						MAX_LED=i;
						}
					}
				}
			}
		}
	}
	SEND_OK=1;	
}

ISR(USART_RX_vect)								{	//Прием данных от блютус 
	if (in_index == in_buffer_SIZE){in_index=0;}else{in_index++;} 		// Не забрали вовремя данные, буфер полон, сбрасываем и пишем сначала но надо бы закольцевать его насовсем и бегать по кругу.
	in_buffer[in_index]=UDR0;
//	LCD_Char(in_buffer[in_index],0);
//	cli();
	if (in_buffer[in_index]=='%'){										//Символ окончания параметра
		while((in_buffer[in_index]!='>')&&(in_index!=0)){in_index--; 	}	//Поиск символа начала пакета
		in_index++;
		dekode(&in_buffer[in_index]);									//Анализируем и декодируем результат.
		in_index=0;
	}
	if (in_buffer[in_index]=='+'){
	_delay_ms(10);
	in_index=0;
	}
//	sei();
}

void clear_LED(void)  { 						//очистка буфера светодиодной ленты
  unsigned char i;
   for(i=0; i<MAX_LED; i++)
   {    
   led[i].r=0;led[i].g=0;led[i].b=0;
   }
}

void led_full(void)  { 							//заливка буфера ленты 1 цветом
  unsigned char i;
  if (bright==0)bright=1;
   for(i=0; i<MAX_LED; i++)
   {    
   led[i].r=led_dot[0].r/(255/bright);
   led[i].g=led_dot[0].g/(255/bright);
   led[i].b=led_dot[0].b/(255/bright);
   }
}

void raduga(unsigned char KOL_LED)     
{//заполняем буфер радугой
unsigned char i;
for(i=0; i<KOL_LED; i++)
     {
      if (i<KOL_LED/3)
	   {
	   led[i].r=(bright-(bright/(KOL_LED/3)*i)); led[i].g=(bright/(KOL_LED/3)*i); led[i].b=0;
	   }
	   else
	   {
		   if ((i>=KOL_LED/3)&&(i<=(KOL_LED/3)*2))
		   {
		   led[i].r=0;led[i].g=(bright-bright/(KOL_LED/3)*(i-(KOL_LED/3)));led[i].b=((bright/(KOL_LED/3))*(i-(KOL_LED/3)));
		   }
           else
           {
			led[i].r=(bright/(KOL_LED/3)*(i-2*(KOL_LED/3)));
			led[i].g=0;
			if ( i== KOL_LED-1)
			led[i].b=0;
            else		
			led[i].b=(bright-(bright/(KOL_LED/3)*(i-2*(KOL_LED/3))));   
           }	
	   }
	 }	 
}

void step_right_loop(void)
{												//сдвиг всех пикселей влево по кругу на
	unsigned char i=MAX_LED-1;
    led_dot[0].r=led[i].r; led_dot[0].g=led[i].g; led_dot[0].b=led[i].b;
	for (i=MAX_LED-1;i>0;i--)
	{
	led[i].r=led[i-1].r;led[i].g=led[i-1].g;led[i].b=led[i-1].b;	
	}	  
      led[0].r=led_dot[0].r; led[0].g=led_dot[0].g;	led[0].b=led_dot[0].b;	
}

void flash(void){
	unsigned char i, e, n;
	for (i=0; i<rand()%50; i++){							//вспышек за серию
		clear_LED();	
		e=rand()%bright;									//яркость вспышки
		n=rand()%MAX_LED;										//Номер диода
		led[n].r=e; led[n].g=e; led[n].b=e;
		ws2812_sendarray((uint8_t *)led,MAX_LED*3);
		_delay_ms(rand()%speed);							//Пауз между одиночными вспышками
    }
	clear_LED();
	ws2812_sendarray((uint8_t *)led,MAX_LED*3);
}
 
void ADC_Init(char n){
	ADMUX = n|((1<<REFS1)|(1<<REFS0)); //опорное напряжение 2.56 ? 1,1? V
	ADCSRA|=(1<<ADEN)|(1<<ADPS2)|(0<<ADPS1)|(0<<ADPS0); //включить ацп, установить делитель на 32 (500 кг) 
}

void UART_Init(void){
	unsigned char eep=eeprom_read_byte(&bitrate);
	UCSR0A=(0<<RXC0) | (0<<TXC0) | (0<<UDRE0) | (0<<FE0) | (0<<DOR0) | (0<<UPE0) | (0<<U2X0) | (0<<MPCM0);
	UCSR0B=(1<<RXCIE0) | (0<<TXCIE0) | (0<<UDRIE0) | (1<<RXEN0) | (0<<TXEN0) | (0<<UCSZ02) | (0<<RXB80) | (0<<TXB80);
	UCSR0C=(0<<UMSEL01) | (0<<UMSEL00) | (0<<UPM01) | (0<<UPM00) | (0<<USBS0) | (1<<UCSZ01) | (1<<UCSZ00) | (0<<UCPOL0);
	UBRR0H=0x00;
	switch(eep) {
			case 0:
			UBRR0L=0x67;			
			break;
			case 1://Baud Rate: 14400
			UBRR0L=0x44;			
			break;
			case 2://Baud Rate: 19200
			UBRR0L=0x33;			
			break;
			case 3://Baud Rate: 38400
			UBRR0L=0x19;			
			break;
			case 4://Baud Rate: 56000
			UBRR0L=0x11;			
			break;
			default: //Baud Rate: 9600
			UBRR0L=0x67;			
	}			
} 
 
uint16_t ADC_read(void)
{
    volatile uint16_t L,H;
    ADCSRA |= (1<<ADSC);         //Начинаем преобразование
    while((ADCSRA & (1<<ADSC))); //проверим закончилось ли аналого-цифровое преобразование
    L = ADCL;
    H = ADCH;
    H<<=8;
    H|=L;
    return H;
}
void step_right(void)
{//сдвиг всех пикселей вправо а 1 первый пиксель черным цветом +
	unsigned char i;
	for (i=MAX_LED-1;i>0;i--)
	{
	led[i].r=led[i-1].r;led[i].g=led[i-1].g;led[i].b=led[i-1].b;	
	}
	led[0].r=0; led[0].g=0; led[0].b=0; //или не черным - сюда писать каким заливать
} 

void TIMER_init(void)
{	
// Timer Period: 4 us -250
TCCR1A=(0<<COM1A1) | (0<<COM1A0) | (0<<COM1B1) | (0<<COM1B0) | (0<<WGM11) | (0<<WGM10);
TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (0<<WGM12) | (0<<CS12) | (0<<CS11) | (1<<CS10);
TCNT1H=0xFF;
TCNT1L=0xC0;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x3F;
OCR1BH=0x00;
OCR1BL=0x00;
}

void FU_transform()
{
    int16_t count,degree;
    unsigned char i,k;
    count = 0;
    for (i=0; i<N/2; i++) {
        for (k=0; k<N; k++) {
            degree = (uint16_t)pgm_read_byte_near(degree_lookup + count)*2;
            count++;
            out_f[i][0] +=  adc[k] * (int16_t)pgm_read_word_near(cos_lookup + degree);
            out_f[i][1] += -adc[k] * (int16_t)pgm_read_word_near(sin_lookup + degree);
        }
        out_f[i][0] /= N;
        out_f[i][0] /= 10000;
        out_f[i][1] /= N;
        out_f[i][1] /= 10000;
    }
} 

unsigned char ADC_read_8(void)
{
    ADCSRA |= (1<<ADSC);         //Начинаем преобразование
    while((ADCSRA & (1<<ADSC))); //проверим закончилось ли аналого-цифровое преобразование
    return ADCH;
}

int __attribute__((noreturn)) main(void)
{
	SEND_OK=1;
	DDRB |= (1<<LED_PIN);   //Делаем нужный пин выходом
	I2C_Init();
	LCD_init(); 
	ADC_Init(0); 
	TIMER_init();
	UART_Init();
	LCD_Clear();
	LCD_Goto(0,0);
	clear_LED();
	unsigned char OUT;
    unsigned char i, color=1;
	unsigned char e=0, m=0, r;
    sei();	//разрешить прерывания
	/*****************************/
	rezim=eeprom_read_byte(&rez);
	if(rezim>4){
	eeprom_write_byte(&rez,1);
	rezim=1;
	}
	/*****************************/
	bright=eeprom_read_byte(&br);
	/*****************************/	
	speed=eeprom_read_byte(&sp);
	/*****************************/
	MAX_LED=eeprom_read_byte(&K_L);
	if (MAX_LED>100){
	eeprom_write_byte(&K_L,16);
	MAX_LED=16;	
	}
	/*****************************/
	
    while(1) {
		switch(rezim) {
			case 0: //вспышки
			flash();
			_delay_ms(rand()%speed*45);
			break;
			
			case 1: //цветомузыка
			raduga(MAX_LED);
			flg=1;

			//250
			TCNT1H=0xFFC0 >> 8;
			TCNT1L=0xFFC0 & 0xff;
			
			TIMSK1=(0<<ICIE1) | (0<<OCIE1B) | (0<<OCIE1A) | (1<<TOIE1);
			while(flg){};			//ожидание работы таймера
			FU_transform();
			//Прогоняем буфер через функцию
			for(i=1; i<N/2; i++) {												//берем по модулю
				if(out_f[i][0]<0)out_f[i][0]*=-1; 
				if(out_f[i][1]<0)out_f[i][1]*=-1;
				OUT = (unsigned char)(out_f[i][0] + out_f[i][1])/4;         	//суммируем  и получаем готовый результат;
				//LCD_Lines(i*8,0,i*8,OUT);										//вывод на экран
				m=m+((MAX_LED%16)*100)/16;
				
				if (m<100){
					for(r=0; r<MAX_LED/16;r++){
						if (OUT==0){
							led[e+r].r=0;       					//для каждого канала вычисляем яркость
							led[e+r].g=0;
							led[e+r].b=0;
						}else
						{
							if (led[e+r].r/(255/OUT)>=51) led[e+r].r=255; else led[e+r].r=5*(led[e+r].r/(255/OUT));
							if (led[e+r].g/(255/OUT)>=51) led[e+r].g=255; else led[e+r].g=5*(led[e+r].g/(255/OUT));
							if (led[e+r].b/(255/OUT)>=51) led[e+r].b=255; else led[e+r].b=5*(led[e+r].b/(255/OUT));
						}
					}
					e=e+MAX_LED/16;
				}
				else{
					for(r=0; r<(MAX_LED/16)+1;r++){
						if (OUT==0){
							led[e+r].r=0;       					//для каждого канала вычисляем яркость
							led[e+r].g=0;
							led[e+r].b=0;
						}
						else{
							if (led[e+r].r/(255/OUT)>=51) led[e+r].r=255; else led[e+r].r=5*(led[e+r].r/(255/OUT));
							if (led[e+r].g/(255/OUT)>=51) led[e+r].g=255; else led[e+r].g=5*(led[e+r].g/(255/OUT));
							if (led[e+r].b/(255/OUT)>=51) led[e+r].b=255; else led[e+r].b=5*(led[e+r].b/(255/OUT));
						}
					}
					e=e+1+MAX_LED/16;
					m=m-100;
				}
				
			}	
			e=0;
			m=0;
			ws2812_sendarray((uint8_t *)led,MAX_LED*3);
			_delay_ms(speed);
			break;
			
			case 2://Ночник
			if (SEND_OK){
			color_decode(0);
			led_full();
			ws2812_sendarray((uint8_t *)led,MAX_LED*3);
			SEND_OK=0;
			}
			break;
			
			case 3://бегущая радуга
			if (SEND_OK){
			clear_LED();
			raduga(MAX_LED);
			ws2812_sendarray((uint8_t *)led,MAX_LED*3);
			_delay_ms(speed);
			SEND_OK=0;
			}
			if (speed!=0){
				step_right_loop();
				ws2812_sendarray((uint8_t *)led,MAX_LED*3);
				_delay_ms(speed);
			}
			break;
			
			case 4:
			color_decode(color);
			led_full();
			ws2812_sendarray((uint8_t *)led,MAX_LED*3);
			color++;
			if (color==0)color=1;
			_delay_ms(speed);
			break;
			

			case 5:
			if (SEND_OK){
			clear_LED();
			ws2812_sendarray((uint8_t *)led,MAX_LED*3);
			SEND_OK=0;
			}
			for (i=0; i<10;i++){
				//OUT=(OUT*i+ADC_read_8())/(i+1);
				m=ADC_read_8();
				if (OUT<m)OUT=m;
				_delay_us(700);
			}
			//OUT=ADC_read_8();
			led[0].r=OUT*5; 
			led[0].g=OUT*5;
			led[0].b=OUT*5;
			OUT=0;
			ws2812_sendarray((uint8_t *)led,MAX_LED*3);
			step_right();
			_delay_ms(speed);
			break;
				
		}
	}
} 